/*
 * DBRecord.java
 * Copyright (C) 2008 Cyber Beans Corporation. All rights reserved.
 */
package jp.co.cybec.cb3.accessor.dbaccess;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.Date;
import java.util.Map;

/**
 * DBレコードを表すインタフェースクラス。
 * @author Lijuan Sun
 */
public interface DBRecord {

	/**
	 * 引数「key」に該当する値をString型で返却します。
	 * @param key キー
	 * @return String
	 */
	String  getString(String key);

	/**
	 * 引数「key」に該当する値をInteger型で返却します。
	 * @param key キー
	 * @return Integer
	 */
	Integer getInteger(String key);

	/**
	 * 引数「key」に該当する値をObject型で返却します。
	 * @param key キー
	 * @return Object
	 */
	Object getObject(String key);

	/**
	 * 引数「key」に該当する値をBigDecimal型で返却します。
	 * @param key キー
	 * @return BigDecimal
	 */
	BigDecimal getBigDecimal(String key);

	/**
	 * 引数「key」に該当する値をLong型で返却します。
	 * @param key キー
	 * @return Long
	 */
	Long getLong(String key);

	/**
	 * 引数「key」に該当する値をFloat型で返却します。
	 * @param key キー
	 * @return Float
	 */
	Float getFloat(String key);

	/**
	 * 引数「key」に該当する値をShort型で返却します。
	 * @param key キー
	 * @return Short
	 */
	Short getShort(String key);

	/**
	 * 引数「key」に該当する値をDate型で返却します。
	 * @param key キー
	 * @return Date
	 */
	Date getDate(String key);

	/**
	 * 引数「key」に該当する値をTimestamp型で返却します。
	 * @param key キー
	 * @return Timestamp
	 */
	Timestamp getTimestamp(String key);

	/**
	 * １レコード分のMap情報を返す。
	 * @return １レコード分のMap情報
	 */
	Map<String, Object> toMap();

	/**
	 * １レコード分のMap情報を返す。
	 * @return １レコード分のMap情報
	 */
	Map<String, String> toMapStringValue();

}
